%% Seminář 7 řešení
%% Úkol 1
% _Spočítejte kompresi a relativní redundanci, pokud každou barvu v obrázku 
% 'red_kodovani.png' (|I1|) kódujeme 2 bity._

I1 = rgb2gray(imread('red_kodovani.png'));
[M,N] = size(I1);
p = n/(M*N);
%% 
% 8-kód

l1 = 8*ones(256,1);
l1_avg = sum(l1.*p);
display(l1_avg);
%% 
% 2-kód

l2 = 2*ones(256,1);
l2_avg = sum(l2.*p);
display(l2_avg);
%% 
% Řešení

b1 = M*N*l1_avg;
b2 = M*N*l2_avg;

% komprese
C = b1/b2;
display(C);

% relativni redundance
R = 1-(1/C);
display(R);
%% Úkol 2
% _Spočítejte kompresi a relativní redundanci, pokud použijeme při kódování 
% obrázku 'red_prostor.png' (|I2|) pro každý řádek 1 byte pro intenzitu a 1 byte 
% pro počet opakujících se prvků._

I2 = imread('red_prostor.png');
[M,N] = size(I2);
p = n/(M*N);
%% 
% 8-kód

l1 = 8*ones(256,1);
l1_avg = sum(l1.*p);

b1 = M*N*l1_avg;
%% 
% Kódování 2 byty na řádek 

b2 = M * 16; % 8 bitu barva, 8 bitu pocet
%% 
% Řešení

% komprese
C = b1/b2;
display(C);

% relativni redundance
R = 1-(1/C);
display(R);
%% Úkol 3
% _Jaká je komprese a relativní redundance výše zmíněného kódu (získaného zjednodušenou 
% RLE kompresí) pro obrázek 'prikladLena.png'._

I = imread('prikladLena.png');
[m, n] = size(I);
vstup_pom = I(:);
vstup(vstup_pom) = 'w';
vstup(vstup_pom==0) = 'b';

[enc, delka_kod] = RLEenc(vstup);

% kody
b1 = m*n;
b2 = delka_kod;

% komprese
C = b1/b2;
display(C);

% relativni redundance
R = 1-(1/C);
display(R);
%% Úkol 4
% _Spočítejte kompresi a relativní redundanci při kódování obrázku 'red_info.png' 
% jednou hodnotou (každý pixel má hodnotu 125)._

I3 = imread('red_info.png');
[M,N] = size(I3);

b1 = M*N*8; % kazdy pixel 8 bite
b2 = 8; % 1 hodnota 

% komprese
C = b1/b2;
display(C);

% relativni redundance
R = 1-(1/C);
display(R);
%% Úkol 5
% _Spočítejte chybu pro obrázek 'red_info.png'  a jeho úpravu, kdy jsou všechny 
% pixely rovny hodnotě 99._

I = imread('red_info.png');
[M,N] = size(I);

I2 = 99*uint8(ones([M,N]));

% immse = Mean-Squared Error.
mse = immse(I, I2);
display(mse);

% root mean-squared error

rmse = sqrt(immse(I, I2));
display(rmse);
%% Pomocné funkce

function [enc, delka] = RLEenc(vstup)
    % kodovani
    enc = '';
    r = 0;
    delka = 0;
    for i = 1 : size(vstup,2)
        a = vstup(i);
        if r == 0
            x = a;
            r = 1;
        else
            if a == x
                r = r + 1;
            else
                enc = [enc num2str(r) x];
                x = a;
                r = 1;
                delka = delka + 9; %pocet je 1 byte, znak 1 bite
            end
        end
    end
    enc = [enc num2str(r) a];
    delka = delka + 9; 
end
%% 
%